package edu;
import  java.util.*;

class Broadcaster extends Thread
{  Enumeration e;
   UpdateEvent event ;
   boolean actionset = false;
   
   Broadcaster() { start(); }
   
   public synchronized void run() {
     try
     { while(true) {
         while(!actionset) wait();
         actionset=false;
         if( event!=null && e!=null && e.hasMoreElements() ) {
           Enumeration ec = e; e=null;
           UpdateEvent eventc = event; event=null;
           while(ec.hasMoreElements()) {
             UpdateListener ul = (UpdateListener) ec.nextElement();
             if(ul!=null) ul.updateOccurred(eventc);
           }// end of while
         }// end of if
       }// end of while()
     } catch(InterruptedException ex) {}
   }// end of run()

   public synchronized void setAction(Enumeration e, UpdateEvent event )
   { this.e=e; this.event=event; actionset=true; notify(); }

}// end of Broadcaster

/**
* @author Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*/
public class UpdateBroadcaster {
  Vector listeners = new Vector();
  Broadcaster b = new Broadcaster();

  public UpdateBroadcaster() { }

  public void addUpdateListener (UpdateListener l) { listeners.addElement(l); }

  public void removeUpdateListener (UpdateListener l) { listeners.removeElement(l); }

  protected void fireUpdate (Object obj) {
    if( listeners.size()>0 ) {
      System.out.println("broadcasting updateOccurred"); 
      b.setAction(listeners.elements(),new UpdateEvent (obj));
      /*UpdateEvent event = new UpdateEvent (obj);
      Enumeration e = listeners.elements();
      while(e.hasMoreElements()) {
        UpdateListener ul = (UpdateListener) e.nextElement();
        if(ul!=null) ul.updateOccurred(event);
      }// end of while*/
    } else System.out.println("No-one listenening"); // end of if
  }// end of fireUpdate()

  /*protected void fireUpdate (Object obj) {
    if( getNumberOfListeners()>0 ) {
      UpdateEvent event = new UpdateEvent (obj);System.out.println("broadcasting updateOccurred"); 
      try
      { Object[] args = new Object[1];
        args[0]=event;
        GenericMessage gm = new GenericMessage(getFirstListener().getClass(),getFirstListener(),"updateOccurred",args);
        broadcastGenericMessage(gm);
      } catch(IllegalArgumentException iae) 
        { ErrorReport.displayErrorMessage(iae.getMessage()); }
    } else System.out.println("No-one listenening"); // end of if
  }// end of fireUpdate()*/

  protected void fireUpdate () {fireUpdate(this); }
    
}// end of UpdateBroadcaster
  
